/********************************************************************************************************************
-   -    HD44780
********************************************************************************************************************/
#include	"pic.h"
// PORTB (lcd)
#define rs  1
#define rw  2
#define en  3



#define bitset(var,bitno) ((var) |= 1 << (bitno)) 
#define bitclr(var,bitno) ((var) &= ~(1 << (bitno)))
//#define Message "C-programm *LCD*"
 //-------------------------------
void delay(int);	//
void  interrupt tc_ovf(void);	//     
unsigned char bin2bcd(unsigned char);//BIN - BCD
void wr_command_lcd(unsigned char);//   lcd
void wr_data_lcd(unsigned char);//    lcd
//----------- --------
unsigned char lcd @ 0x06; // PORTB
const unsigned  char StartMessage[16]= {
0x50, 0x49, 0x43, 0x2B, 0x4C, 0x43, 0x44, 0x20, 0xBE, 0x70, 0x6F, 0xB3, 0x65, 0x70, 0xBA, 0x61
 };
const unsigned  char lineSize=124;
const unsigned  char RunMessage[124]= {
0xA8, 0x6F, 0xB7, 0xE3, 0x70, 0x61, 0xB3, 0xBB, 0xC7, 0xC6, 0x21, 0x20, 0x45, 0x63, 0xBB, 0xB8, 
0x20, 0x79, 0xE3, 0x61, 0xB5, 0xBF, 0x63, 0xC7, 0x20, 0xBE, 0x70, 0x6F, 0xC0, 0xB8, 0xBF, 0x61, 
0xBF, 0xC4, 0x20, 0xC5, 0xBF, 0x6F, 0x20, 0x63, 0x6F, 0x6F, 0xB2, 0xE6, 0x65, 0xBD, 0xB8, 0x65, 
0x2C, 0x20, 0x42, 0xC3, 0x20, 0xB3, 0x63, 0xB5, 0x20, 0x63, 0xE3, 0x65, 0xBB, 0x61, 0xBB, 0xB8, 
0x20, 0xBE, 0x70, 0x61, 0xB3, 0xB8, 0xBB, 0xC4, 0xBD, 0x6F, 0x2E, 0x20, 0xA9, 0x63, 0xBE, 0x65, 
0x78, 0x6F, 0xB3, 0x21, 0x20, 0x68, 0x74, 0x74, 0x70, 0x3A, 0x2F, 0x2F, 0x77, 0x77, 0x77, 0x2E, 
0x73, 0x63, 0x68, 0x65, 0x6D, 0x7A, 0x2E, 0x6E, 0x61, 0x72, 0x6F, 0x64, 0x2E, 0x72, 0x75, 0x20,
0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
 };

main() 
		{
		unsigned char i,currentPOS;
		TRISB=0x00;	
		di();	

//--------- lcd-----------
	lcd=0;
	delay(1300);
	lcd=0x30;
	bitset (lcd, en); bitclr (lcd, en);// _/\_
	delay(7);	
	bitset (lcd, en); bitclr (lcd, en);// _/\_
	delay(230);
	wr_command_lcd(0x20);
	wr_command_lcd(0x28);	
	wr_command_lcd(0x0C);
	wr_command_lcd(0x06);
	wr_command_lcd(0x01);
	delay(230);
//----------  --------
wr_command_lcd(0x80);
	for	(i=0;i<8;i++) wr_data_lcd(StartMessage[i]);
wr_command_lcd(0xC0);
	for	(i=8;i<16;i++) wr_data_lcd(StartMessage[i]);
delay(56000);
delay(56000);

	while(1) {
for (currentPOS=0; currentPOS<lineSize-16;currentPOS++) {
//----------  --------
	wr_command_lcd(0x80);
	for	(i=currentPOS;i<currentPOS+8;i++) wr_data_lcd(RunMessage[i]);
	wr_command_lcd(0xC0);
	for	(i=currentPOS+8;i<currentPOS+16;i++) wr_data_lcd(RunMessage[i]);
	delay(24000);	
	}
	}

	}
//=====      =======
void  interrupt tc_ovf(void) {
	unsigned char  A;
	unsigned char BCD;
	di();
	TMR0=0x65;
	T0IF=0;
	ei();
	}

//============--  T=19us+k*13us __ k=(T-19us)/13us --==========
void delay(kmax) 
	{	unsigned int ki;
	for (ki=0; ki<kmax; ki++);//""    
					}		  //

//================ BIN - BCD ================
unsigned char bin2bcd(unsigned char i)
{
	return ( ( i / 10 ) * 0x10 + ( i % 10 ) );
} // Bin2Dec


//=============     lcd  =======
void wr_command_lcd(unsigned char cmd_lcd) {
	bitclr (lcd,rs); bitclr (lcd,rw);
	lcd=cmd_lcd & 0xF0;
	bitset (lcd, en); bitclr (lcd, en);// _/\_
	lcd=(cmd_lcd<<4) & 0xF0;
	bitset (lcd, en); bitclr (lcd, en);// _/\_
	delay(230);
	}
// =============     lcd =======
void wr_data_lcd(unsigned char dat_lcd) {
	bitset (lcd,rs); bitclr (lcd,rw);
	lcd=(dat_lcd & 0xF0) | 0x02;
	bitset (lcd, en); bitclr (lcd, en);// _/\_
	lcd=((dat_lcd<<4) & 0xF0) | 0x02;
	bitset (lcd, en); bitclr (lcd, en);// _/\_	
	delay(230);
	bitclr (lcd,rs);
}
